Index: extra/pylint.rc
===================================================================
--- extra/pylint.rc	(revision 6e68289f10e05b04aa6bcbba67042e16cb307883)
+++ extra/pylint.rc	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -67,4 +67,14 @@
     locally-enabled,
     locally-disabled,
+    #no-else-return,
+    #invalid-name,
+    #fixme,
+    #too-many-lines,
+    #too-many-locals,
+    #too-many-branches,
+    #too-many-statements,
+    #too-many-instance-attributes,
+    #too-many-return-statements,
+    #no-self-use,
 
 [REPORTS]
@@ -109,5 +119,5 @@
 good-names=_,
     input, id,
-    h, i, j, k, n, p, v, w, x, y, z,
+    h, i, j, k, n, p, u, v, w, x, y, z,
     q, qx, qy, qz, Q, Qx, Qy, Qz,
     dt, dx, dy, dz, dq,
Index: sasmodels/bumps_model.py
===================================================================
--- sasmodels/bumps_model.py	(revision 2c4a190a64dff2df7c3a9d3ea13d6d566b439ecd)
+++ sasmodels/bumps_model.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -26,4 +26,5 @@
     from .kernel import KernelModel
     from .modelinfo import ModelInfo
+    from .resolution import Resolution
     Data = Union[Data1D, Data2D]
 except ImportError:
@@ -180,8 +181,16 @@
     @property
     def resolution(self):
+        # type: () -> Union[None, Resolution]
+        """
+        :class:`sasmodels.Resolution` applied to the data, if any.
+        """
         return self._resolution
 
     @resolution.setter
     def resolution(self, value):
+        # type: (Resolution) -> None
+        """
+        :class:`sasmodels.Resolution` applied to the data, if any.
+        """
         self._resolution = value
 
@@ -270,5 +279,5 @@
         Save the model parameters and data into a file.
 
-        Not Implemented.
+        Not Implemented except for sesans fits.
         """
         if self.data_type == "sesans":
Index: sasmodels/compare.py
===================================================================
--- sasmodels/compare.py	(revision 4de145843b2267c4f1e8be16517c48de601151b6)
+++ sasmodels/compare.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -725,5 +725,5 @@
         set_integration_size(model_info, ngauss)
 
-    if (dtype != "default" and not dtype.endswith('!') 
+    if (dtype != "default" and not dtype.endswith('!')
             and not (kernelcl.use_opencl() or kernelcuda.use_cuda())):
         raise RuntimeError("OpenCL not available " + kernelcl.OPENCL_ERROR)
@@ -772,5 +772,5 @@
         opts['pars'] = parse_pars(opts, maxdim=maxdim)
         if opts['pars'] is None:
-            return
+            return limits
         result = run_models(opts, verbose=True)
         if opts['plot']:
@@ -822,6 +822,6 @@
     args = dict((k, v) for k, v in args.items()
                 if "_pd" not in k
-                   and ":" not in k
-                   and k not in ("background", "scale", "theta", "phi", "psi"))
+                and ":" not in k
+                and k not in ("background", "scale", "theta", "phi", "psi"))
     args = args.copy()
 
@@ -896,5 +896,5 @@
     # work with trimmed data, not the full set
     sorted_err = np.sort(abs(err.compressed()))
-    if len(sorted_err) == 0:
+    if sorted_err.size == 0:
         print(label + "  no valid values")
         return
Index: sasmodels/convert.py
===================================================================
--- sasmodels/convert.py	(revision 21c93c37dac1eb1749656b388dd13e5fa29e63f3)
+++ sasmodels/convert.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -384,4 +384,5 @@
 
 def revert_name(model_info):
+    """Translate model name back to the name used in SasView 3.x"""
     oldname, _ = CONVERSION_TABLE.get(model_info.id, [None, {}])
     return oldname
@@ -653,4 +654,7 @@
 
 def test_backward_forward():
+    """
+    Test conversion of model parameters from 4.x to 3.x and back.
+    """
     from .core import list_models
     L = lambda name: _check_one(name, seed=1)
Index: sasmodels/core.py
===================================================================
--- sasmodels/core.py	(revision d92182f88244a4ce39a4ef855ac8295e073ff65f)
+++ sasmodels/core.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -323,4 +323,7 @@
 
 def test_composite_order():
+    """
+    Check that mixture models produce the same result independent of ordder.
+    """
     def test_models(fst, snd):
         """Confirm that two models produce the same parameters"""
@@ -337,4 +340,5 @@
 
     def build_test(first, second):
+        """Construct pair model test"""
         test = lambda description: test_models(first, second)
         description = first + " vs. " + second
@@ -382,5 +386,5 @@
 
 def list_models_main():
-    # type: () -> None
+    # type: () -> int
     """
     Run list_models as a main program.  See :func:`list_models` for the
@@ -391,9 +395,9 @@
     try:
         models = list_models(kind)
-    except Exception as exc:
+        print("\n".join(models))
+    except Exception:
         print(list_models.__doc__)
         return 1
-
-    print("\n".join(list_models(kind)))
+    return 0
 
 if __name__ == "__main__":
Index: sasmodels/data.py
===================================================================
--- sasmodels/data.py	(revision bd7630de7da8bd67aa24b8fc036b2dcc1bc72a16)
+++ sasmodels/data.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -500,5 +500,5 @@
             mdata = masked_array(data.y, data.mask.copy())
             mdata[~np.isfinite(mdata)] = masked
-            if view is 'log':
+            if view == 'log':
                 mdata[mdata <= 0] = masked
             plt.errorbar(data.x, scale*mdata, yerr=data.dy, fmt='.')
@@ -514,5 +514,5 @@
             mtheory = masked_array(theory)
             mtheory[~np.isfinite(mtheory)] = masked
-            if view is 'log':
+            if view == 'log':
                 mtheory[mtheory <= 0] = masked
             plt.plot(theory_x, scale*mtheory, '-')
Index: sasmodels/details.py
===================================================================
--- sasmodels/details.py	(revision 885753a925cb7e3423bdd0db6db395557a6fb1c6)
+++ sasmodels/details.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -236,9 +236,9 @@
     npars = kernel.info.parameters.npars
     nvalues = kernel.info.parameters.nvalues
-    scalars = [value for value, _dispersity, _weight in mesh]
+    scalars = [value for value, dispersity, weight in mesh]
     # skipping scale and background when building values and weights
-    _values, dispersity, weights = zip(*mesh[2:npars+2]) if npars else ((), (), ())
-    #weights = correct_theta_weights(kernel.info.parameters, dispersity, weights)
-    length = np.array([len(w) for w in weights])
+    value, dispersity, weight = zip(*mesh[2:npars+2]) if npars else ((), (), ())
+    #weight = correct_theta_weights(kernel.info.parameters, dispersity, weight)
+    length = np.array([len(w) for w in weight])
     offset = np.cumsum(np.hstack((0, length)))
     call_details = make_details(kernel.info, length, offset[:-1], offset[-1])
@@ -246,5 +246,5 @@
     data_len = nvalues + 2*sum(len(v) for v in dispersity)
     extra = (32 - data_len%32)%32
-    data = np.hstack((scalars,) + dispersity + weights + ZEROS[:extra])
+    data = np.hstack((scalars,) + dispersity + weight + ZEROS[:extra])
     data = data.astype(kernel.dtype)
     is_magnetic = convert_magnetism(kernel.info.parameters, data)
Index: sasmodels/direct_model.py
===================================================================
--- sasmodels/direct_model.py	(revision 2c4a190a64dff2df7c3a9d3ea13d6d566b439ecd)
+++ sasmodels/direct_model.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -31,5 +31,4 @@
 from . import resolution2d
 from .details import make_kernel_args, dispersion_mesh
-from .modelinfo import DEFAULT_BACKGROUND
 from .product import RADIUS_MODE_ID
 
Index: sasmodels/generate.py
===================================================================
--- sasmodels/generate.py	(revision cd289474f05b7a39cccd795f21f84befdf2a8788)
+++ sasmodels/generate.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -190,4 +190,12 @@
 
 def get_data_path(external_dir, target_file):
+    """
+    Search for the target file relative in the installed application.
+
+    Search first in the location of the generate module in case we are
+    running directly from the distribution.  Search next to the python
+    executable for windows installs.  Search in the ../Resources directory
+    next to the executable for Mac OS/X installs.
+    """
     path = abspath(dirname(__file__))
     if exists(joinpath(path, target_file)):
@@ -225,6 +233,6 @@
 #
 # NOTE: there is an RST_PROLOG at the end of this file which is NOT
-# used for the bundled documentation. Still as long as we are defining the macros
-# in two places any new addition should define the macro in both places.
+# used for the bundled documentation. Still as long as we are defining the
+# macros in two places any new addition should define the macro in both places.
 RST_UNITS = {
     "Ang": "|Ang|",
@@ -530,5 +538,5 @@
 
 def test_tag_float():
-    """check that floating point constants are properly identified and tagged with 'f'"""
+    """Check that floating point constants are identified and tagged with 'f'"""
 
     cases = """
@@ -707,5 +715,6 @@
     return False
 
-_SHELL_VOLUME_PATTERN = re.compile(r"(^|\s)double\s+shell_volume[(]", flags=re.MULTILINE)
+_SHELL_VOLUME_PATTERN = re.compile(r"(^|\s)double\s+shell_volume[(]",
+                                   flags=re.MULTILINE)
 def contains_shell_volume(source):
     # type: (List[str]) -> bool
@@ -801,5 +810,5 @@
             logger.warn("oriented shapes should define Iqac or Iqabc")
         else:
-            raise ValueError("Expected function Iqac or Iqabc for oriented shape")
+            raise ValueError("Expected Iqac or Iqabc for oriented shape")
 
     # Define the parameter table
@@ -815,14 +824,24 @@
         refs = _call_pars("_v.", partable.form_volume_parameters)
         if is_hollow:
-            call_volume = "#define CALL_VOLUME(_form, _shell, _v) do { _form = form_volume(%s); _shell = shell_volume(%s); } while (0)"%((",".join(refs),)*2)
+            call_volume = (
+                "#define CALL_VOLUME(_form, _shell, _v) "
+                "do { _form = form_volume(%s); _shell = shell_volume(%s); } "
+                "while (0)") % ((",".join(refs),)*2)
         else:
-            call_volume = "#define CALL_VOLUME(_form, _shell, _v) do { _form = _shell = form_volume(%s); } while (0)"%(",".join(refs))
+            call_volume = (
+                "#define CALL_VOLUME(_form, _shell, _v) "
+                "do { _form = _shell = form_volume(%s); } "
+                "while (0)") % (",".join(refs))
         if model_info.effective_radius_type:
-            call_effective_radius = "#define CALL_EFFECTIVE_RADIUS(_mode, _v) effective_radius(_mode, %s)"%(",".join(refs))
+            call_effective_radius = (
+                "#define CALL_EFFECTIVE_RADIUS(_mode, _v) "
+                "effective_radius(_mode, %s)") % (",".join(refs))
     else:
         # Model doesn't have volume.  We could make the kernel run a little
         # faster by not using/transferring the volume normalizations, but
         # the ifdef's reduce readability more than is worthwhile.
-        call_volume = "#define CALL_VOLUME(_form, _shell, _v) do { _form = _shell = 1.0; } while (0)"
+        call_volume = (
+            "#define CALL_VOLUME(_form, _shell, _v) "
+            "do { _form = _shell = 1.0; } while (0)")
     source.append(call_volume)
     source.append(call_effective_radius)
@@ -879,12 +898,11 @@
     source.append("#define MAGNETIC_PARS %s"%",".join(str(k) for k in magpars))
     source.append("#define PROJECTION %d"%PROJECTION)
-    # TODO: allow mixed python/opencl kernels?
-    ocl = _kernels(kernel_code, call_iq, clear_iq, call_iqxy, clear_iqxy, model_info.name)
-    dll = _kernels(kernel_code, call_iq, clear_iq, call_iqxy, clear_iqxy, model_info.name)
-
-    result = {
-        'dll': '\n'.join(source+dll[0]+dll[1]+dll[2]),
-        'opencl': '\n'.join(source+ocl[0]+ocl[1]+ocl[2]),
-    }
+    wrappers = _kernels(kernel_code, call_iq, clear_iq,
+                        call_iqxy, clear_iqxy, model_info.name)
+    code = '\n'.join(source + wrappers[0] + wrappers[1] + wrappers[2])
+
+    # Note: Identical code for dll and opencl.  This may not always be the case
+    # so leave them as separate entries in the returned value.
+    result = {'dll': code, 'opencl': code}
     return result
 
Index: sasmodels/gengauss.py
===================================================================
--- sasmodels/gengauss.py	(revision ff31782cc25cfbfea355acdd6d0204c959b41dcc)
+++ sasmodels/gengauss.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -1,6 +1,7 @@
 #!/usr/bin/env python
+"""
+Generate the Gauss-Legendre integration points and save them as a C file.
+"""
 from __future__ import division, print_function
-
-import sys
 
 import numpy as np
@@ -8,4 +9,7 @@
 
 def gengauss(n, path):
+    """
+    Save the Gauss-Legendre integration points for length *n* into file *path*.
+    """
     z, w = leggauss(n)
 
Index: sasmodels/guyou.py
===================================================================
--- sasmodels/guyou.py	(revision b3703f51bafe67afb8acefe986ad7466720f755b)
+++ sasmodels/guyou.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -68,4 +68,5 @@
 
 def ellipticJi(u, v, m):
+    """Returns [sn, cn, dn](u + iv|m)."""
     scalar = np.isscalar(u) and np.isscalar(v) and np.isscalar(m)
     u, v, m = np.broadcast_arrays(u, v, m)
@@ -100,7 +101,6 @@
     ]
 
-# calculate F(phi+ipsi|m).
-# see Abramowitz and Stegun, 17.4.11.
 def ellipticFi(phi, psi, m):
+    """Returns F(phi+ipsi|m). See Abramowitz and Stegun, 17.4.11."""
     if np.any(phi == 0):
         scalar = np.isscalar(phi) and np.isscalar(psi) and np.isscalar(m)
@@ -207,6 +207,6 @@
         plt.plot(x, y, 'g')
 
-    for long in range(-limit, limit+1, step):
-        x, y = guyou_invert(scale*long, scale*long_line)
+    for longitude in range(-limit, limit+1, step):
+        x, y = guyou_invert(scale*longitude, scale*long_line)
         plt.plot(x, y, 'b')
     plt.xlabel('longitude')
